## sundials 6.4.1+dfsg1

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban, David J. Gardner, Cody J. Balos,
#                and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ===============================================================
# Initial setup.
# ===============================================================

cmake_minimum_required(VERSION 3.12)

# Project SUNDIALS (initially only C supported)
# sets PROJECT_SOURCE_DIR and PROJECT_BINARY_DIR variables.
project(SUNDIALS C)

# Specify the location of additional CMAKE modules
set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/macros
  ${PROJECT_SOURCE_DIR}/cmake/tpl
  )

# MACRO definitions
include(SundialsCMakeMacros)
include(CMakePrintHelpers)
include(CheckCSourceCompiles)
include(FindPackageHandleStandardArgs)


# Set some variables with info on the SUNDIALS project
set(PACKAGE_BUGREPORT "sundials-users@llnl.gov")
set(PACKAGE_NAME "SUNDIALS")
set(PACKAGE_STRING "SUNDIALS 6.4.1")
set(PACKAGE_TARNAME "sundials")

# Set SUNDIALS version numbers
sundials_git_version() # sets SUNDIALS_GIT_VERSION
message(STATUS "SUNDIALS_GIT_VERSION: ${SUNDIALS_GIT_VERSION}")

# (use "" for the version label if none is needed)
set(PACKAGE_VERSION_MAJOR "6")
set(PACKAGE_VERSION_MINOR "4")
set(PACKAGE_VERSION_PATCH "1")
set(PACKAGE_VERSION_LABEL "")

if(PACKAGE_VERSION_LABEL)
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}"
  )
else()
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
  )
endif()

# Specify the VERSION and SOVERSION for shared libraries

set(arkodelib_VERSION "5.4.1")
set(arkodelib_SOVERSION "5")

set(cvodelib_VERSION "6.4.1")
set(cvodelib_SOVERSION "6")

set(cvodeslib_VERSION "6.4.1")
set(cvodeslib_SOVERSION "6")

set(idalib_VERSION "6.4.1")
set(idalib_SOVERSION "6")

set(idaslib_VERSION "5.4.1")
set(idaslib_SOVERSION "5")

set(kinsollib_VERSION "6.4.1")
set(kinsollib_SOVERSION "6")

set(cpodeslib_VERSION "0.0.0")
set(cpodeslib_SOVERSION "0")

set(nveclib_VERSION "6.4.1")
set(nveclib_SOVERSION "6")

set(sunmatrixlib_VERSION "4.4.1")
set(sunmatrixlib_SOVERSION "4")

set(sunlinsollib_VERSION "4.4.1")
set(sunlinsollib_SOVERSION "4")

set(sunnonlinsollib_VERSION "3.4.1")
set(sunnonlinsollib_SOVERSION "3")

set(sundialslib_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
)
set(sundialslib_SOVERSION "${PACKAGE_VERSION_MAJOR}")

# ===============================================================
# Initial Setup
# ===============================================================

# Prohibit in-source build
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  print_error("In-source build prohibited.")
endif()

# Organize targets into folders when using an IDE
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Get correct build paths automatically, but expose LIBDIR and
# INCLUDEDIR as a regular cache variable so that a user can more
# easily see what they were set to by GNUInstallDirs.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR)
mark_as_advanced(CLEAR CMAKE_INSTALL_INCLUDEDIR)

# Suffixes to use for static and shared targets.
set(_STATIC_LIB_SUFFIX
    "_static"
    CACHE INTERNAL "" FORCE
)
set(_SHARED_LIB_SUFFIX
    "_shared"
    CACHE INTERNAL "" FORCE
)

# A list of all the alias targets created.
set(_SUNDIALS_ALIAS_TARGETS ""
    CACHE INTERNAL "" FORCE)

# ===============================================================
# Build options to be processed first
# ===============================================================

include(SundialsDeprecated)
include(SundialsBuildOptionsPre)

# ===============================================================
# Options for external packages
# ===============================================================

include(SundialsTPLOptions)

# ===============================================================
# Options for examples
# ===============================================================

include(SundialsExampleOptions)

# ===============================================================
# Setup compilers
# ===============================================================

include(SundialsSetupCompilers)

# ===============================================================
# Setup third-party libraries
# ===============================================================

include(SundialsSetupTPLs)

# ===============================================================
# Build options to be proccessed last
# ===============================================================

include(SundialsBuildOptionsPost)

# ===============================================================
# At this point all the configuration options are set.
# Setup the sundials_config.h.
# ===============================================================

include(SundialsSetupConfig)

# ===============================================================
# Add src and tests; optionally add examples and unit tests.
# ===============================================================

# Add selected packages and modules to the build
add_subdirectory(src)

# Add selected examples to the build
if(_BUILD_EXAMPLES)
  include(SundialsSetupTesting)
  add_subdirectory(examples)
endif()

# Add benchmarks to the build
if(BUILD_BENCHMARKS)
  add_subdirectory(benchmarks)
endif()

# Add unit tests to the build if they are enabled
if(SUNDIALS_TEST_UNITTESTS)
  add_subdirectory(test/unit_tests)
endif()

# ===============================================================
# Install configuration header files and license file.
# ===============================================================

# install sundials_export header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_export.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# install configured header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_config.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# install shared Fortran 2003 modules
if(BUILD_FORTRAN_MODULE_INTERFACE)
  # While the .mod files get generated for static and shared
  # libraries, they are identical. So only install one set
  # of the .mod files.
  if(BUILD_STATIC_LIBS)
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_STATIC/
            DESTINATION ${Fortran_INSTALL_MODDIR}
    )
  else()
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_SHARED/
            DESTINATION ${Fortran_INSTALL_MODDIR}
    )
  endif()
endif()

# install license and notice files
install(FILES "${PROJECT_SOURCE_DIR}/LICENSE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)
install(FILES "${PROJECT_SOURCE_DIR}/NOTICE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# create package version file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  SUNDIALSConfigVersion.cmake
  VERSION ${PACKAGE_VERSION}
  COMPATIBILITY SameMajorVersion
)

# install targets
install(
  EXPORT sundials-targets
  FILE SUNDIALSTargets.cmake
  NAMESPACE SUNDIALS::
  DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)

# install SUNDIALSConfig.cmake
configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/SUNDIALSConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
  INSTALL_DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfigVersion.cmake"
        DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)

# Export targets so build directory can be used directly
export(
  EXPORT sundials-targets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSTargets.cmake"
  NAMESPACE SUNDIALS::
)

=== src/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner, Slaven Peles, and
#                Cody Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# src level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# Add all of the shared SUNDIALS components
add_subdirectory(sundials)
add_subdirectory(nvector)
add_subdirectory(sunmatrix)
add_subdirectory(sunlinsol)
add_subdirectory(sunnonlinsol)
add_subdirectory(sunmemory)

# ARKODE library
if(BUILD_ARKODE)
  add_subdirectory(arkode)
endif()

# CVODE library
if(BUILD_CVODE)
  add_subdirectory(cvode)
endif()

# CVODES library
if(BUILD_CVODES)
  add_subdirectory(cvodes)
endif()

# IDA library
if(BUILD_IDA)
  add_subdirectory(ida)
endif()

# IDAS library
if(BUILD_IDAS)
  add_subdirectory(idas)
endif()

# KINSOL library
if(BUILD_KINSOL)
  add_subdirectory(kinsol)
endif()

# CPODES library
if(BUILD_CPODES)
  add_subdirectory(cpodes)
endif()

=== swig/Makefile ===
# ---------------------------------------------------------------
# Programmer: Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Makefile to generate SUNDIALS fortran interfaces with swig
# ---------------------------------------------------------------

ARKODE=farkode_mod farkode_arkstep_mod farkode_erkstep_mod farkode_mristep_mod
CVODE=fcvode_mod
CVODES=fcvodes_mod
IDA=fida_mod
IDAS=fidas_mod
KINSOL=fkinsol_mod
GENERIC=fsundials_types_mod fsundials_nvector_mod fsundials_matrix_mod fsundials_linearsolver_mod fsundials_nonlinearsolver_mod fsundials_futils_mod fsundials_context_mod fsundials_profiler_mod fsundials_logger_mod
NVECTOR=openmp pthreads serial parallel manyvector mpiplusx
SUNMATRIX=band dense sparse
SUNLINSOL=band dense klu spbcgs spfgmr spgmr sptfqmr pcg
SUNNONLINSOL=newton fixedpoint

INCLUDES=-I../include

.PHONY: generic arkode cvode cvodes ida idas kinsol nvector sunmatrix sunlinsol sunnonlinsol patch

all: generic arkode cvode cvodes ida idas kinsol nvector sunmatrix sunlinsol sunnonlinsol patch

arkode: $(ARKODE:%:arkode/%.i)
	@for i in ${ARKODE} ; do \
		echo "swig -fortran -outdir ../src/arkode/fmod -o ../src/arkode/fmod/$${i}.c ${INCLUDES} arkode/$${i}.i" ; \
		swig -fortran -outdir ../src/arkode/fmod -o ../src/arkode/fmod/$${i}.c ${INCLUDES} arkode/$${i}.i ; \
	done

cvode: $(CVODE:%:cvode/%.i)
	@for i in ${CVODE} ; do \
		echo "swig -fortran -outdir ../src/cvode/fmod -o ../src/cvode/fmod/$${i}.c ${INCLUDES} cvode/$${i}.i" ; \
		swig -fortran -outdir ../src/cvode/fmod -o ../src/cvode/fmod/$${i}.c ${INCLUDES} cvode/$${i}.i ; \
	done

cvodes: $(CVODE:%:cvodes/%.i)
	@for i in ${CVODES} ; do \
		echo "swig -fortran -outdir ../src/cvodes/fmod -o ../src/cvodes/fmod/$${i}.c ${INCLUDES} cvodes/$${i}.i" ; \
		swig -fortran -outdir ../src/cvodes/fmod -o ../src/cvodes/fmod/$${i}.c ${INCLUDES} cvodes/$${i}.i ; \
	done

ida: $(IDA:%:ida/%.i)
	@for i in ${IDA} ; do \
		echo "swig -fortran -outdir ../src/ida/fmod -o ../src/ida/fmod/$${i}.c ${INCLUDES} ida/$${i}.i" ; \
		swig -fortran -outdir ../src/ida/fmod -o ../src/ida/fmod/$${i}.c ${INCLUDES} ida/$${i}.i ; \
	done

idas: $(IDAS:%:idas/%.i)
	@for i in ${IDAS} ; do \
		echo "swig -fortran -outdir ../src/idas/fmod -o ../src/idas/fmod/$${i}.c ${INCLUDES} idas/$${i}.i" ; \
		swig -fortran -outdir ../src/idas/fmod -o ../src/idas/fmod/$${i}.c ${INCLUDES} idas/$${i}.i ; \
	done

kinsol: $(KINSOL:%:kinsol/%.i)
	@for i in ${KINSOL} ; do \
		echo "swig -fortran -outdir ../src/kinsol/fmod -o ../src/kinsol/fmod/$${i}.c ${INCLUDES} kinsol/$${i}" ; \
		swig -fortran -outdir ../src/kinsol/fmod -o ../src/kinsol/fmod/$${i}.c ${INCLUDES} kinsol/$${i}.i ; \
	done

generic: $(GENERIC:%:sundials/%.i)
	@for i in ${GENERIC} ; do \
		echo "swig -fortran -outdir ../src/sundials/fmod -o ../src/sundials/fmod/$${i}.c ${INCLUDES} $${i}" ; \
		swig -fortran -outdir ../src/sundials/fmod -o ../src/sundials/fmod/$${i}.c ${INCLUDES} sundials/$${i}.i ; \
	done

nvector: $(NVECTOR:%:nvector/fnvector_%_mod.i) mpimanyvector
	@for i in ${NVECTOR} ; do \
		echo "swig -fortran -outdir ../src/nvector/$${i}/fmod -o ../src/nvector/$${i}/fmod ${INCLUDES} nvector/fnvector_$${i}_mod.i" ; \
		swig -fortran -outdir ../src/nvector/$${i}/fmod -o ../src/nvector/$${i}/fmod/fnvector_$${i}_mod.c ${INCLUDES} nvector/fnvector_$${i}_mod.i ; \
	done

mpimanyvector: nvector/fnvector_mpimanyvector_mod.i
	@echo "swig -fortran -outdir ../src/nvector/manyvector/fmod -o ../src/nvector/manyvector/fmod ${INCLUDES} nvector/fnvector_mpimanyvector_mod.i" ; \
	swig -fortran -outdir ../src/nvector/manyvector/fmod -o ../src/nvector/manyvector/fmod/fnvector_mpimanyvector_mod.c ${INCLUDES} nvector/fnvector_mpimanyvector_mod.i ; \

sunmatrix: $(SUNMATRIX:%:sunmatrix/fsunmatrix_%_mod.i)
	@for i in ${SUNMATRIX} ; do \
		echo "swig -fortran -outdir ../src/sunmatrix/$${i}/fmod -o ../src/sunmatrix/$${i}/fmod ${INCLUDES} sunmatrix/fsunmatrix_$${i}_mod.i" ; \
		swig -fortran -outdir ../src/sunmatrix/$${i}/fmod -o ../src/sunmatrix/$${i}/fmod/fsunmatrix_$${i}_mod.c ${INCLUDES} sunmatrix/fsunmatrix_$${i}_mod.i ; \
	done

sunlinsol: $(SUNLINSOL:%:sunlinsol/fsunlinsol_%_mod.i)
	@for i in ${SUNLINSOL} ; do \
		echo "swig -fortran -outdir ../src/sunlinsol/$${i}/fmod -o ../src/sunlinsol/$${i}/fmod ${INCLUDES} sunlinsol/fsunlinsol_$${i}_mod.i" ; \
		swig -fortran -outdir ../src/sunlinsol/$${i}/fmod -o ../src/sunlinsol/$${i}/fmod/fsunlinsol_$${i}_mod.c ${INCLUDES} sunlinsol/fsunlinsol_$${i}_mod.i ; \
	done

sunnonlinsol: $(SUNNONLINSOL:%:sunnonlinsol/fsunnonlinsol_%_mod.i)
	@for i in ${SUNNONLINSOL} ; do \
		echo "swig -fortran -outdir ../src/sunnonlinsol/$${i}/fmod -o ../src/sunnonlinsol/$${i}/fmod ${INCLUDES} sunnonlinsol/fsunnonlinsol_$${i}_mod.i" ; \
		swig -fortran -outdir ../src/sunnonlinsol/$${i}/fmod -o ../src/sunnonlinsol/$${i}/fmod/fsunnonlinsol_$${i}_mod.c ${INCLUDES} sunnonlinsol/fsunnonlinsol_$${i}_mod.i ; \
	done

patch: .FORCE
	cd ..; git apply swig/fnvector-getarraypointer.patch

clean:
	rm ../src/**/fmod/*.c; rm ../src/**/fmod/*.f90

.FORCE: ;

=== benchmarks/diffusion_2D/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------

if(BUILD_ARKODE OR BUILD_CVODE OR BUILD_IDA)

  # Shared sources
  set(shared_sources
    diffusion_2D.hpp
    diffusion_2D.cpp
    preconditioner_jacobi.cpp)

  # Benchmark prefix
  set(benchmark_prefix ${SUNDIALS_SOURCE_DIR}/benchmarks/diffusion_2D/)

  add_prefix(${benchmark_prefix} shared_sources)

  # MPI + Serial
  add_subdirectory(mpi_serial)

  # MPI + CUDA/HIP
  if(BUILD_NVECTOR_CUDA OR BUILD_NVECTOR_HIP)
    add_subdirectory(mpi_gpu)
  endif()

  install(FILES README.md
    DESTINATION "${CMAKE_INSTALL_BINDIR}/benchmarks/diffusion_2D")

endif()

=== benchmarks/nvector/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# benchmarks/nvector level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

add_subdirectory(serial)

if(BUILD_NVECTOR_PARALLEL)
  add_subdirectory(parallel)
endif()

if(BUILD_NVECTOR_MPIPLUSX)
  add_subdirectory(mpiplusx)
endif()

if(BUILD_NVECTOR_PARHYP)
  add_subdirectory(parhyp)
endif()

if(BUILD_NVECTOR_PTHREADS)
  add_subdirectory(pthreads)
endif()

if(BUILD_NVECTOR_OPENMP)
  add_subdirectory(openmp)
endif()

if(BUILD_NVECTOR_OPENMPDEV)
  add_subdirectory(openmpdev)
endif()

if(BUILD_NVECTOR_PETSC)
  add_subdirectory(petsc)
endif()

if(BUILD_NVECTOR_CUDA)
  add_subdirectory(cuda)
endif()

if(BUILD_NVECTOR_HIP)
  add_subdirectory(hip)
endif()

if(BUILD_NVECTOR_RAJA)
  add_subdirectory(raja)
endif()

if(BUILD_NVECTOR_SYCL)
  add_subdirectory(sycl)
endif()

if(BUILD_NVECTOR_KOKKOS)
  add_subdirectory(kokkos)
endif()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/plot_nvector_performance_results.py
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

=== doc/cvode/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for CVODE examples documentation
# -----------------------------------------------------------------

EXAMPLES   = cv_examples

EX_FILES = \
${EXAMPLES}.tex \
cv_ex_intro.tex \
cv_ex_serial.tex \
cv_ex_parallel.tex \
cv_ex_parhyp.tex \
cv_ex_fortran.tex \
cv_ex_tests.tex

include ../Makefile.in

=== doc/cvodes/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for CVODES examples documentation
# -----------------------------------------------------------------

EXAMPLES   = cvs_examples

EX_FILES = \
${EXAMPLES}.tex \
cvs_ex_intro.tex \
cvs_ex_fwd.tex \
cvs_ex_adj.tex \
cvs_ex_tests.tex

include ../Makefile.in

=== doc/ida/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for IDA documentation
# -----------------------------------------------------------------

EXAMPLES   = ida_examples

EX_FILES = \
${EXAMPLES}.tex     \
ida_ex_intro.tex    \
ida_ex_serial.tex   \
ida_ex_parallel.tex \
ida_ex_petsc.tex    \
ida_ex_trilinos.tex    \
ida_ex_fortran.tex  \
ida_ex_codes.tex

include ../Makefile.in

=== doc/idas/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for IDAS examples documentation
# -----------------------------------------------------------------

EXAMPLES   = idas_examples

EX_FILES = \
${EXAMPLES}.tex \
idas_ex_intro.tex \
idas_ex_fwd.tex \
idas_ex_adj.tex

include ../Makefile.in

=== doc/install_guide/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -W --keep-going
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make all".
all:
	@$(SPHINXBUILD) -M latexpdf "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)

.PHONY: all Makefile

latexpdf: all

clean: Makefile
	@$(SPHINXBUILD) -M clean "$(SOURCEDIR)" "$(BUILDDIR)"

=== doc/kinsol/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2022, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for KINSOL examples documentation
# -----------------------------------------------------------------

EXAMPLES   = kin_examples

EX_FILES = \
${EXAMPLES}.tex \
kin_ex_intro.tex \
kin_ex_c.tex \
kin_ex_cxx.tex \
kin_ex_fortran.tex

include ../Makefile.in

=== doc/superbuild/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make all".
all:
	@$(SPHINXBUILD) -M html "$(SOURCEDIR)" "$(BUILDDIR)"

.PHONY: all Makefile

html: all

clean: Makefile
	@$(SPHINXBUILD) -M clean "$(SOURCEDIR)" "$(BUILDDIR)"

=== debian/changelog ===
sundials (6.4.1+dfsg1-3build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:56:06 +1100

sundials (6.4.1+dfsg1-3build3) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:37:18 +0000

sundials (6.4.1+dfsg1-3build2) noble; urgency=medium

  * No-change rebuild against petsc 3.19

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 13 Feb 2024 06:27:57 +0000

sundials (6.4.1+dfsg1-3build1) mantic; urgency=medium

  * No-change rebuild against libklu2 

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 14 Aug 2023 12:19:02 +0000

=== debian/control ===
Source: sundials
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>,
           Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               chrpath,
               cmake,
               python3,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev,
               libsuitesparse-dev,
               libhypre-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/sundials
Vcs-Git: https://salsa.debian.org/science-team/sundials.git
Homepage: https://www.llnl.gov/CASC/sundials/
Rules-Requires-Root: no

Package: libsundials-arkode5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Breaks: libsundials-nvecparallel-mpi4 (<<6.4.1+dfsg1-2)
Replaces: libsundials-nvecparallel-mpi4 (<<6.4.1+dfsg1-2)
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-sunlinsol3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-sunmatrix4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode5               (= ${binary:Version}),
         libsundials-cvode6                (= ${binary:Version}),
         libsundials-cvodes6               (= ${binary:Version}),
         libsundials-ida6                  (= ${binary:Version}),
         libsundials-idas5                 (= ${binary:Version}),
         libsundials-kinsol6               (= ${binary:Version}),
         libsundials-nvecserial6           (= ${binary:Version}),
         libsundials-nvecparallel-mpi6     (= ${binary:Version}),
         libsundials-nvecparallel-pthread6 (= ${binary:Version}),
         libsundials-nvecparallel-openmp6  (= ${binary:Version}),
         libsundials-nvecparallel-hypre6   (= ${binary:Version}),
         libsundials-nvecparallel-petsc6   (= ${binary:Version}),
         libsundials-sunlinsol3            (= ${binary:Version}),
         libsundials-sunmatrix4            (= ${binary:Version}),
         cmake,
         mpi-default-dev,
         libhypre-dev,
         petsc-dev,
         gfortran,
         pkg-config,
         ${misc:Depends}
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.

Package: libsundials-fortran-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode5               (= ${binary:Version}),
         libsundials-cvode6                (= ${binary:Version}),
         libsundials-cvodes6               (= ${binary:Version}),
         libsundials-ida6                  (= ${binary:Version}),
         libsundials-idas5                 (= ${binary:Version}),
         libsundials-kinsol6               (= ${binary:Version}),
         libsundials-nvecserial6           (= ${binary:Version}),
         libsundials-nvecparallel-mpi6     (= ${binary:Version}),
         libsundials-nvecparallel-pthread6 (= ${binary:Version}),
         libsundials-nvecparallel-openmp6  (= ${binary:Version}),
         libsundials-nvecparallel-hypre6   (= ${binary:Version}),
         libsundials-nvecparallel-petsc6   (= ${binary:Version}),
         libsundials-sunlinsol3            (= ${binary:Version}),
         libsundials-sunmatrix4            (= ${binary:Version}),
         cmake,
         mpi-default-dev,
         libhypre-dev,
         petsc-dev,
         gfortran,
         pkg-config,
         ${misc:Depends}
Description: Package providing everything for SUNDIALS dev work. Fortran files
 This package contains all development fortran files necessary to build
 applications using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). All examples and documentation links live in this package
 as well.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
#export CTEST_OUTPUT_ON_FAILURE=1

include /usr/share/dpkg/architecture.mk

HYPRE_VERSION=$(shell dpkg -s libhypre-dev | grep Version | awk '{print $$2}')
HYPRE_LIB=$(shell if dpkg --compare-versions $(HYPRE_VERSION) lt 2.20.0-1exp3~ ; then echo HYPRE_core; else echo HYPRE; fi)

extra_flags += \
	-DCMAKE_Fortran_COMPILER=gfortran \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_STATIC_LIBS:BOOL=ON \
	-DBUILD_FORTRAN_MODULE_INTERFACE:BOOL=ON \
	-DENABLE_MPI:BOOL=ON \
	\
	-DENABLE_LAPACK:BOOL=OFF\
	\
	-DEXAMPLES_ENABLE_C:BOOL=ON \
	-DEXAMPLES_ENABLE_CXX:BOOL=ON \
	-DEXAMPLES_ENABLE_F2003:BOOL=ON \
	-DEXAMPLES_INSTALL:BOOL=ON \
	\
	-DENABLE_OPENMP:BOOL=ON \
	-DENABLE_PTHREAD:BOOL=ON \
	\
	-DENABLE_KLU:BOOL=ON \
	-DKLU_INCLUDE_DIR=/usr/include/suitesparse \
	-DKLU_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	\
	-DENABLE_PETSC:BOOL=ON \
	\
	-DENABLE_HYPRE:BOOL=ON \
	-DHYPRE_INCLUDE_DIR=/usr/include/hypre \
	-DHYPRE_LIBRARY=-l$(HYPRE_LIB) \
	\
	-DCMAKE_C_FLAGS=-fcommon



# Debian doesn't ship superlu-mt currently, so I turn off this support
extra_flags += -DENABLE_SUPERLUMT:BOOL=OFF


BUILDDIR = $(CURDIR)/debian/build


%:
	dh $@ --buildsystem=cmake  --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

# Hack from https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
# The OpenMPI variable prevents FTBFS when there are not enough CPUs (see #910352 and #849974)
override_dh_auto_test:
	$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),true,(cd debian/build; OMPI_MCA_rmaps_base_oversubscribe=1 ../nofakeroot ctest))

override_dh_auto_install:
	dh_auto_install
# I strip out all the RPATH/RUNPATH tags from my shared objects. These all point
# to libraries that actually live in standard locations, so the tags are not
# needed
	find debian/tmp/ -name '*.so' -o -name '*.so.*' -exec chrpath -d '{}' \;

# Strip extra license file
	rm debian/tmp/usr/include/sundials/LICENSE

# We copy READMEs by hand because they need to be renamed
execute_after_dh_installdocs:
	mkdir -p debian/libsundials-dev/usr/share/doc/libsundials-dev
	for module in arkode cvode cvodes ida idas kinsol; do \
		cp src/$${module}/README.md debian/libsundials-dev/usr/share/doc/libsundials-dev/README.$${module}.md; \
	done

override_dh_compress:
	dh_compress -Xexamples/

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR)

=== debian/tests/control ===
Tests: arkode
Depends: build-essential, libsundials-dev
Restrictions: allow-stderr
